"""
A Stack class. We might need one.
$Id: Stack.py,v 1.7 2000/08/29 10:51:49 konrad Exp $
(C) Konrad Anton 2000
"""
from Exceptions import *

class Stack:
    """a stack that grows and never shrinks, for efficiency's sake?

    Instance vars:
       items : a list of items
       top : the first empty position in items 
    """
    def __init__(self, initial_items=None):
        "initialize Stack from initial_items"
        self.items=initial_items or []
        self.top = len(self.items)

    def copy(self):
        "shallowly copy this stack"
        return Stack(self.items[:])
    
    def push(self, item):
        its=self.items
        top=self.top
        if top >= len(its):
            its.append(item)
        else:
            its[top] = item
        self.top = top + 1

    def pop(self, line=0,col=0):
        if self.top >= 1:
            self.top=self.top-1
            return self.items[self.top]
        else:
            raise GML_StackUnderflowError(line,col)
            
    def multipop(self, n, line=0,col=0):
        "get the n topmost elements, topmost last"
        if self.top >= n:
            self.top=self.top-n
            return self.items[self.top:self.top+n]
        else:
            raise GML_StackUnderflowError(line,col)

    def popall(self):
        return self.items[:self.top]
