"""
Test framework for optimizer
$Id: TestOpti.py,v 1.2 2000/08/29 09:53:02 konrad Exp $
"""
import sys
from Parser import GML_Parser, GML_Lexer
import PrettyPrint
import Stackmachine, Exceptions, Optimizer

try:
    filename = sys.argv[1]
except:
    filename = "spheres.gml"

try:
    if filename == '-':
        thefile = sys.stdin
    else:
        thefile=open(filename, "rt")
    print "Parsing...",filename
    pa=GML_Parser(GML_Lexer(thefile))

    prog=pa.getProgram()
    print "\n\nBEFORE:"
    PrettyPrint.InstrListPrinter(prog).printAll()
    print "\n\nAFTER:"
    opti=Optimizer.Optimizer()
    (optilist, asyms) = opti.run(prog)
    PrettyPrint.InstrListPrinter(optilist).printAll()
    print "\nSymbol report:"
    for k in asyms.keys():
        print k, Optimizer.Optimizer.accessStateNames[asyms[k]]

except Exceptions.GML_Error, e:
    print "Fatal error:\n",str(e)
